jQuery(function ($) {
    var create_dialog = function (
                    id, title, structure, submitname, submitvalue) {
        var nonceid = 'tube-ninja_nonce',
            nonce = $('input#'+nonceid).val(),
            $div = $(document.createElement('div'));
        $div.attr('id', id);
        var $form = $('<form method="post" action="?page=tn-menu"></form>').appendTo($div),
            $table = $('<table class="form-table"></table>').appendTo($form),
            $tbody = $('<tbody></tbody>').appendTo($table);
        $form.append('<input type="hidden" name="' +
                            nonceid + '" value="' + nonce + '" />')
        $form.css({'padding': '1em'});
        for (var key in structure) {
            var label = structure[key];
            $(document.createElement('tr')).appendTo($tbody).append(
                '<th scope="row"><label for="'+key+'">'+label+
                            '</label></th>',
                '<td><input type="text" name="'+key+'" /></td>'
            );
        }
        $form.append('<input id="'+submitname+
                    '" type="submit" value="'+submitvalue+
                    '" name="'+submitname+
                    '" />');
        $('body').append($div);
        $div.dialog({
            autoOpen: false,
            modal: true,
            zIndex: 10000,
            dialogClass: 'wp-dialog',
            title: title,
            width: '350px'
        });
        return $div;
    };
    var dialog_fields = {
        'link-slug' : 'Slug for the link',
        'first-link' : 'First link',
        'second-link' : 'Second link'
    };
    var $dialogdiv = create_dialog(
            'new-link-dialog',
            'Create new link',
            dialog_fields,
            'new-link-submit',
            'Create link'),
       $editdialog = create_dialog(
            'edit-link-dialog',
            'Edit link',
            dialog_fields,
            'edit-link-submit',
            'Update link');
    $editdialog.find('form').append('<input type="hidden" name="id" />');
    
    $('#new-link-top, #new-link-bottom').click(function () {
        $dialogdiv.dialog('open');
        return false;
    });
    $('a.link-edit').click(function () {
        var $tr = $(this).parents('tr');

        $editdialog.find("input[name='link-slug']").val(
                        $tr.find('.slug a').text());
        $editdialog.find("input[name='first-link']").val(
                        $tr.find('.firstlink').text());
        $editdialog.find("input[name='second-link']").val(
                        $tr.find('.secondlink').text());
        $editdialog.find("input[name='id']").val(
                        $tr.find('th input').attr('value'));
        $editdialog.dialog('open');
        return false;
    });
});
