<?php

/* function tn_reset_settings_form() {
    ?>
    <div>
        <form method="post">
        <?php
            wp_nonce_field(
                    'tn_reset_settings_nonce', 'tn_reset_settings_nonce');
            submit_button('Reset Ad Bar Settings',
                          'primary', 'tn_adbar_reset');
        ?>
        </form>
    </div>
    <?php
} */

/** ********************** Admin page additions *************************/

add_action('admin_menu', 'tn_add_menu_page');
function tn_add_menu_page() {
    $menu_page = add_menu_page(
            TN_PLUGIN_NAME,    // page title
            TN_PLUGIN_NAME,    // menu title
            'edit_dashboard',  // capability required for the menu to be shown
            TN_MENU_SLUG,      // menu slug
            'tn_admin_menu'    // function
    );
    add_action("admin_print_scripts-$menu_page", 'tn_menu_script');
    add_action("load-$menu_page", 'tn_load_admin_menu');
}

function tn_load_admin_menu() {
    global $tn_admin_message, $tn_admin_message_type;
    $tn_admin_message = false;
    $tn_admin_message_type = 'updated';
    if (isset($_REQUEST['new-link-submit'])) {
        check_admin_referer(TN_PLUGIN_FOLDER.'_nonce',
                             TN_PLUGIN_FOLDER.'_nonce');
        $tn_admin_message =
                "Link for <b>{$_REQUEST['link-slug']}</b> created.";
        if (false === tnlm_add_link(
            $_REQUEST['link-slug'],
            $_REQUEST['first-link'],
            $_REQUEST['second-link']
        )) {
            $tn_admin_message =
                "Error creating link for <b>{$_REQUEST['link-slug']}</b>.";
            $tn_admin_message_type = 'error';
        }
    }
    if (isset($_REQUEST['edit-link-submit'])) {
        check_admin_referer(TN_PLUGIN_FOLDER.'_nonce',
                             TN_PLUGIN_FOLDER.'_nonce');
        $tn_admin_message =
                "Link for <b>{$_REQUEST['link-slug']}</b> updated.";
        if (false === tnlm_edit_link(
            $_REQUEST['id'],
            $_REQUEST['link-slug'],
            $_REQUEST['first-link'],
            $_REQUEST['second-link']
        )) {
            $tn_admin_message =
                "Error updating link for <b>{$_REQUEST['link-slug']}</b>.";
            $tn_admin_message_type = 'error';
        }
    }

    // resetting adbar settings
    /* if (isset($_REQUEST['tn_adbar_reset'])) {
        check_admin_referer(
                'tn_reset_settings_nonce', 'tn_reset_settings_nonce');
        //tn_reset_diggdigg_options();
        tn_create_default_options('update');
        $tn_admin_message = 'Ad Bar settings reset to defaults.';
    } */
    add_action('admin_notices', 'tn_admin_notices');
}

function tn_menu_script() {
    // color picker
    wp_enqueue_script('farbtastic');
    wp_enqueue_style('farbtastic');
    // font picker
    wp_enqueue_script('tn_adbar_menu',
            plugins_url('/js/tn-adbar-menu.js', __FILE__),
            array('jquery'));
    wp_enqueue_script('tn_linkmonetizer_menu',
            plugins_url('/js/tn-linkmonetizer-menu.js', __FILE__),
            array('jquery', 'jquery-ui-dialog', 'jquery-ui-widget'));
    wp_enqueue_style('wp-jquery-ui-dialog');
}

// call register settings function
add_action('admin_init', 'tn_register_settings');
function tn_register_settings() {
    // adbar stats
    register_setting(
            'tn_adbar_stats_group',
            TN_ADBAR_STATS,
            'tn_adbar_stats_reset'
    );

    register_setting(
            TN_ADBAR_OPTION.'_group',   // option group
            TN_ADBAR_OPTION,            // option name
            'tn_settings_validate'      // sanitize callback
    );
		
    register_setting(
            TN_YOUTUBE_OPTION.'_group',   // option group
            TN_YOUTUBE_OPTION            // option name
    );
    // general settings

    add_settings_section(
            'tn_youtube_general',                 // ID
            'General settings',                 // title
            'tn_youtube_settings_section_text',   // callback
            TN_MENU_SLUG_YOUTUBE                        // page
    );
    
    // Ad Bar settings

    add_settings_section(
            'tn_adbar_general',                 // ID
            'Ad Bar',                 // title
            'tn_adbar_settings_section_text',   // callback
            TN_MENU_SLUG                        // page
    );
    add_settings_field(
            'tn-youtube-api_key',      // ID
            'Youtube API key',          // title
            'tn_youtube_input',          // callback
            TN_MENU_SLUG_YOUTUBE,               // page
            'tn_youtube_general',         // section
						array(
							'name'	=> TN_YOUTUBE_OPTION
						)
		);
    /** option to show or hide the ad bar **/
    add_settings_field(
            'tn-adbar-show_adbar',      // ID
            'Show Ad Bar',          // title
            'tn_option_input',          // callback
            TN_MENU_SLUG,               // page
            'tn_adbar_general',         // section
            array('id' => 'tn-adbar-show_adbar',
                  'section' => 'tn_adbar_general',
                  'type' => 'checkbox',
                  'name' => TN_ADBAR_OPTION.'[show_adbar]',
                  'key' => 'show_adbar')
    );
    /** option to use A/B testing on the ad bar **/
    add_settings_field(
            'tn-adbar-use_a_b',         // ID
            'Use A/B testing',          // title
            'tn_option_input',          // callback
            TN_MENU_SLUG,               // page
            "tn_adbar_general",         // section
            array('id' => 'tn-adbar-use_a_b',
                  'section' => 'tn_adbar_general',
                  'type' => 'checkbox',
                  'name' => TN_ADBAR_OPTION.'[use_a_b]',
                  'key' => 'use_a_b')
    );

    // A/B testing settings
    add_settings_section(
            'tn_adbar_a', // ID
            'Version A settings', // title
            'tn_adbar_settings_section_text', // callback
            TN_MENU_SLUG // page
    );
    add_settings_section(
            'tn_adbar_b', // ID
            'Version B settings', // title
            'tn_adbar_settings_section_text', // callback
            TN_MENU_SLUG // page
    );

    // font, size, color, bgcolor, bordercolor, message, linktext, linkurl
    $option_versions = array('a', 'b');
    $option_options = array(
        'font' => 'Font',
        'size' => 'Size',
        'color' => 'Text color',
        'bgcolor' => 'Background color',
        'bordercolor' => 'Border color',
        'message' => 'Message',
        'linktext' => 'Link text',
        'linkurl' => 'Link URL',
        'linkbgcolor' => 'Link background color',
        'linktextcolor' => 'Link text color'
    );
    foreach ($option_versions as $version) {
        foreach ($option_options as $key => $title) {
            add_settings_field(
                "tn-adbar-$key-$version",       // ID
                $title,                         // title
                'tn_adbar_ab_input',            // callback
                TN_MENU_SLUG,                   // page
                "tn_adbar_$version",            // section
                array('version' => $version,    // args to the callback
                    'key' => $key, 'title' => $title)
            );
        }
    }
}

function tn_youtube_settings_section_text($sec) {
    if ($sec['id'] === 'tn_youtube_general') {
        echo '<p>'.TN_YOUTUBE_SETTINGS_DESC.'</p>';
    }
}
function tn_adbar_settings_section_text($sec) {
    if ($sec['id'] === 'tn_adbar_general') {
        echo '<p>'.TN_ADBAR_SETTINGS_DESC.'</p>';
    }
}

function tn_youtube_input($arg) {
    $option = get_option(TN_YOUTUBE_OPTION);
    $id = $arg['id']; $name = $arg['name'];
    $key = $arg['key'];
    ?>
        <input id="<?php echo $id; ?>"
               name="<?php echo $name; ?>"
               size="40" value="<?php echo $option; ?>" />
		<?php
}
function tn_option_input($arg) {
    $option = get_option(TN_ADBAR_OPTION);
    $type = $arg['type'];
    $id = $arg['id']; $name = $arg['name'];
    $key = $arg['key'];
    if ('checkbox' === $type) {
        ?>
        <input type="checkbox"
            id="<?php echo $id ?>" name="<?php echo $name ?>"
            value="1"
            <?php if ($option[$key]) { echo 'checked="checked"'; } ?> />
        <?php
    } else {
        ?>
        <input id="<?php echo $id; ?>"
               name="<?php echo $name; ?>"
               size="40" value="<?php echo $option[$key]; ?>" />
        <?php
    }
}

function tn_adbar_ab_input ($arg) {
    $version = $arg['version']; $key = $arg['key']; $title = $arg['title'];
    $options = get_option(TN_ADBAR_OPTION);
    $option = preg_replace('/"/', '&quot;', $options[$version][$key]);
    $id = "tn-adbar-$key-$version";
    $is_color_item = (false !== strpos($key, 'color'));
    if ($is_color_item) echo '<div class="tn-color">';
    ?>
    <input id="<?php echo $id; ?>"
        <?php if ('font' === $key) echo 'class="tn-font-selector"' ?>
        name="<?php echo TN_ADBAR_OPTION."[$version][$key]"; ?>"
        type="text" value="<?php echo esc_html($option); ?>"
        style="width: 500px" />
    <?php
    if ('size' === $key) echo 'px';
    if ($is_color_item) {
        ?>
        <div class="tn-colorpicker-dialog" title="<?php echo $title; ?>">
            <div class="tn-colorpicker"
                id="<?php echo "tn-adbar-$key-$version-colorpicker"; ?>"></div>
        </div>
        </div> <!-- .tn-color -->
        <?php
    }
}

function tn_settings_validate($input) {
    $newinput = get_option(TN_ADBAR_OPTION);
    foreach ($input as $key => $value) {
        $newinput[$key] = $value;
    }
    $newinput['use_a_b'] = (bool)$input['use_a_b'];
    $newinput['show_adbar'] = (bool)$input['show_adbar'];
    foreach (array('a', 'b') as $version) {
        $newinput[$version]['mouseover_linkbgcolor'] =
            tn_adbar_get_mouseover_color($newinput[$version]['linkbgcolor']);
    }
    return $newinput;
}

function tn_adbar_stats_reset($input) {
    global $tn_adbar_blank_stats;
    if (is_string($input) && strpos($input, 'Reset') !== false) {
        return $tn_adbar_blank_stats;
    }
    return $input;
}
function tn_admin_notices() {
    global $tn_admin_message, $tn_admin_message_type;
    if ($tn_admin_message) {
        echo "<div class=\"$tn_admin_message_type\"><p>$tn_admin_message</p></div>";
    }
}

function tn_admin_menu() {
    $headers = array(
        'version'           => 'Version',
        'load'              => 'Impressions',
        'click'             => 'Clicks',
        'clickthrough'      => 'Clickthrough Rate'
    );
    $stats = get_option(TN_ADBAR_STATS);

    $data = array(
        array('A', $stats['load']['version-a'], $stats['click']['version-a'],
            $stats['load']['version-a'] != 0 ?
                        ((int)(0.5 + 10000 * $stats['click']['version-a'] /
                        $stats['load']['version-a']))/100 . '%' :
                        '&nbsp;&mdash;&nbsp;'
        ),
        array('B', $stats['load']['version-b'], $stats['click']['version-b'],
            $stats['load']['version-b'] != 0 ?
                        ((int)(0.5 + 10000 * $stats['click']['version-b'] /
                        $stats['load']['version-b']))/100 . '%' :
                        '&nbsp;&mdash;&nbsp;'
        )
    );
    ?>
    <div class="wrap">
    <h2><?php echo TN_PLUGIN_NAME ?></h2>
    <div>
      <h3><?php echo TN_ADBAR_STATS_HEADER; ?></h3>
        <table class="widefat">
        <thead><tr>
            <?php foreach ($headers as $header) echo "<th>$header</th>"; ?>
        </tr></thead>
        <tbody>
            <?php foreach ($data as $row) {
                echo '<tr';
                    if ($row[0] === 'A') echo ' class="alternate"'; echo '>';
                foreach ($row as $item) echo "<td>$item</td>";
                echo '</tr>';
            } ?>
        </tbody>
        </table>
        <form method="post" action="options.php">
        <?php
            settings_fields('tn_adbar_stats_group');
            submit_button(
                    'Reset stats', 'primary', TN_ADBAR_STATS);
        ?>
        </form>
    </div>
    <?php tnlm_admin_menu(); ?>
    <div>
      <h3>Options</h3>
        <div class="yt_settings">
        <form method="post" action="options.php">
            <?php settings_fields( TN_YOUTUBE_OPTION.'_group' ); ?>
						<?php do_settings_sections(TN_MENU_SLUG_YOUTUBE); ?>
            <?php submit_button('Save API key'); ?>
        </form>
        </div>
				<form method="post" action="options.php">
            <?php settings_fields( TN_ADBAR_OPTION.'_group' ); ?>
            <?php #settings_fields( TN_YOUTUBE_OPTION ); ?>
            <!-- divider -->
            <?php do_settings_sections(TN_MENU_SLUG); ?>
            <?php submit_button(); ?>
        </form>
    </div>
    <?php /* tn_reset_settings_form(); */ ?>
    </div> <!-- class="wrap" -->
    <?php
}
