<?php

/***************** bundling Digg Digg and the theme ************************/

require_once('class-tgm-plugin-activation.php');

add_action('tgmpa_register', 'tn_require_plugins');
function tn_require_plugins() {
    // $diggfile = 'digg-digg.5.2.9.zip';
    $diggfile = 'digg-digg.5.3.0.zip';
    $plugins = array(
        array(
            'name'               => 'Digg Digg',
            'slug'               => 'digg-digg',
            'source'             => plugins_url("/zip/$diggfile", __FILE__),
            'required'           => false,
            'version'            => '',
            'force_activation'   => false,
            'force_deactivation' => false,
            'external_url'       => '',
        )
//         ,array(
//             'name'               => 'WP Tube Ninja Theme',
//             'slug'               => 'tn-theme',
//             'source'             => plugins_url('/zip/tn-theme.zip',
//                                                 __FILE__),
//             'required'           => false,
//             'version'            => '',
//             'force_activation'   => false,
//             'force_deactivation' => false,
//             'external_url'       => '',
//         )
    );

    $theme_text_domain = 'tube-ninja';

    /**
     * Array of configuration settings. Amend each line as needed.
     * If you want the default strings to be available under your own theme domain,
     * leave the strings uncommented.
     * Some of the strings are added into a sprintf, so see the comments at the
     * end of each line for what each argument will be.
     */
    $config = array(
        'domain'            => $theme_text_domain,          // Text domain - likely want to be the same as your theme.
        'default_path'      => '',                          // Default absolute path to pre-packaged plugins
        'parent_menu_slug'  => 'themes.php',                // Default parent menu slug
        'parent_url_slug'   => 'themes.php',                // Default parent URL slug
        'menu'              => 'install-required-plugins',  // Menu slug
        'has_notices'       => true,                        // Show admin notices or not
        'is_automatic'      => false,                       // Automatically activate plugins after installation or not
        'message'           => '',                          // Message to output right before the plugins table
        'strings'           => array(
            'page_title'                                => __( 'Install Required Plugins', $theme_text_domain ),
            'menu_title'                                => __( 'Install Plugins', $theme_text_domain ),
            'installing'                                => __( 'Installing Plugin: %s', $theme_text_domain ), // %1$s = plugin name
            'oops'                                      => __( 'Something went wrong with the plugin API.', $theme_text_domain ),
            'notice_can_install_required'               => _n_noop( 'WP Tube Ninja requires the following plugin: %1$s.', 'WP Tube Ninja requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_install_recommended'            => _n_noop( 'WP Tube Ninja recommends the following plugin: %1$s.', 'WP Tube Ninja  recommends the following plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_install'                     => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
            'notice_can_activate_required'              => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_activate_recommended'           => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_activate'                    => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
            'notice_ask_to_update'                      => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_update'                      => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
            'install_link'                              => _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
            'activate_link'                             => _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
            'return'                                    => __( 'Return to Required Plugins Installer', $theme_text_domain ),
            'plugin_activated'                          => __( 'Plugin activated successfully.', $theme_text_domain ),
            'complete'                                  => __( 'All plugins installed and activated successfully. %s', $theme_text_domain ), // %1$s = dashboard link
            'nag_type'                                  => 'updated' // Determines admin notice type - can only be 'updated' or 'error'
        )
    );

    tgmpa( $plugins, $config );

}


add_action('init', 'tn_initialize_diggdigg');
// add_action('activated_plugin', 'tn_initialize_diggdigg', 10, 1);
function tn_initialize_diggdigg() {
//     if (strpos($plugin, 'digg-digg') === False) return;
    if (!tn_is_diggdigg_installed()) {
        add_option(TN_DIGGDIGG_INITIALIZED, 'no');
    } else {
        add_option(TN_DIGGDIGG_INITIALIZED, 'yes');
    }

    if (tn_is_diggdigg_installed() &&
        'yes' !== get_option(TN_DIGGDIGG_INITIALIZED)) {
        update_option(TN_DIGGDIGG_INITIALIZED, 'yes');
        tn_reset_diggdigg_options();
    }
}

function tn_reset_diggdigg_options () {
    if (!tn_is_diggdigg_installed()) return;

    global $ddFloatButtons;

    $defaults = array(
        'dd_status_option_display' => 'on',
        'display_option_post' => 'on',
        'category_option_radio' => 'category_option_radio_include',
        'category_option_include' => 'All',
        'category_option_exclude' => 'None',
        'dd_float_option_left' => 65,
        'dd_float_option_top' => 0,
        'dd_comment_anchor_option' => 'on',
        'dd_twitter_button_weight' => 110,
        'dd_twitter_ajax_left_float' => 'on',
        'dd_reddit_button_weight' => 99,
        'dd_linkedin_button_weight' => 99,
        'dd_linkedin_ajax_left_float' => 'on',
        'dd_gbuzz_button_weight' => 98,
        'dd_stumbleupon_button_weight' => 97,
        'dd_dzone_button_weight' => 97,
        'dd_tweetmeme_button_weight' => 97,
        'dd_topsy_button_weight' => 96,
        'dd_fblike_button_weight' => 96,
        'dd_fblike_xfbml_button_weight' => 96,
        'dd_fblike_xfbml_ajax_left_float' => 'on',
        'dd_fbshare_button_weight' => 95,
        'dd_digg_button_weight' => 95,
        'dd_google1_button_weight' => 95,
        'dd_google1_ajax_left_float' => 'on',
        'dd_fbshareme_button_weight' => 94,
        'dd_buffer_button_weight' => 94,
        'dd_delicious_button_weight' => 93,
        'dd_ybuzz_button_weight' => 90,
        'dd_comments_button_weight' => 88,
        'dd_designbump_button_weight' => 87,
        'dd_serpd_button_weight' => 86,
        'dd_webblend_button_weight' => 85,
        'dd_blogengage_button_weight' => 84,
        'dd_flattr_button_weight' => 10,
        'dd_pinterest_button_weight' => 10,
        'digg_digg_save' => 'Save changes',
        'dd_extra_option_email_sharethis' => ''
    );
    foreach($ddFloatButtons[DD_FLOAT_BUTTON_DISPLAY] as $key => $value){

        foreach(array_keys($value->wp_options) as $option){
            if(isset($defaults[$option])){
                $value->wp_options[$option] = $defaults[$option];
            } else {
                $value->wp_options[$option] = DD_EMPTY_VALUE;
            }
        }

        if(($value->getOptionAjaxLeftFloat()!=DD_DISPLAY_OFF)){
            $ddFloatButtons[DD_FLOAT_BUTTON_FINAL][$key] = $value;
        }

    }

    update_option(DD_FLOAT_BUTTON, $ddFloatButtons);

    $float_display_config = get_option(DD_FLOAT_DISPLAY_CONFIG);
    $float_display_config['dd_float_option']['dd_float_option_left'] = 80;//65;
    $float_display_config['dd_comment_anchor_option']
            ['dd_comment_anchor_option_status'] = 'on';
    update_option(DD_FLOAT_DISPLAY_CONFIG, $float_display_config);
}

function tn_is_diggdigg_installed() {
    global $ddFloatButtons;
    return ('5' == get_option('dd_client_version') &&
            defined('DD_FLOAT_BUTTON_DISPLAY') &&
            defined('DD_EMPTY_VALUE') &&
            defined('DD_DISPLAY_OFF') &&
            defined('DD_FLOAT_BUTTON_FINAL') &&
            defined('DD_FLOAT_BUTTON') &&
            defined('DD_FLOAT_DISPLAY_CONFIG') &&
            isset($ddFloatButtons));
}
