<!doctype html>
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
<head>
    <title><?php
        if (is_single()) {
            single_post_title();
        }
        elseif (is_home() || is_front_page()) {
            bloginfo('name');
            echo ' | ';
            bloginfo('description');
            page_number();
        }
        elseif (is_page()) {
            single_post_title('');
        }
        elseif (is_search()) {
            bloginfo('name');
            echo ' | ';
            _e('Search results for ', 'tn-theme');
            echo esc_html($s);
            page_number();
        }
        elseif (is_404()) {
            bloginfo('name');
            echo ' | '; _e('Not Found', 'tn-theme');
        }
        else {
            bloginfo('name'); wp_title('|'); page_number();
        }
    ?></title>

    <meta http-equiv="content-type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>" />

    <link rel="stylesheet" type="text/css" href="<?php bloginfo('stylesheet_url'); ?>" />

    <?php if (is_singular()) wp_enqueue_script('comment-reply'); ?>

    <?php wp_head(); ?>

    <link rel="alternate" type="application/rss+xml" href="<?php bloginfo('rss2_url'); ?>" title="<?php printf(__('%s latest posts', 'tn-theme'), esc_html(get_bloginfo('name'), 1)); ?>" />
    <link rel="alternate" type="application/rss+xml" href="<?php bloginfo('comments_rss2_url') ?>" title="<?php printf(__('%s latest comments', 'tn-theme' ), esc_html(get_bloginfo('name'), 1)); ?>" />
    <link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />
</head>
<body>
<div id="layout">
 <div id="central">
  <div id="header">
    <div id="branding">
      <div id="blog-title">
        <span>
          <a href="<?php
                bloginfo('url'); ?>" title="<?php
                bloginfo('name'); ?>" rel="home">
            <img src="<?php echo get_option('tn_theme_logo_url'); ?>"
                 alt="<?php bloginfo('name'); ?>" />
          </a>
        </span>
      </div>
    </div><!-- #branding -->
        <?php 
	  wp_page_menu(array('sort_column' => 'menu_order',
			     'show_home' => __('Home', 'tube-ninja')));
          //'sort_column=menu_order');
	  //wp_nav_menu(array('theme_location' => 'header-menu'));
        ?>

  </div><!-- #header -->

  <!-- div id="main" -->