ytsearch = (function ($) {
  return {
    YOUTUBE_API_KEY : tn_youtube_api_key.key(),
    YOUTUBE_PREV : false,
    YOUTUBE_NEXT : false,
    YOUTUBE_ICON :
        'http://s.ytimg.com/yt/img/creators_corner/YouTube/youtube_24x24.png',
    YOUTUBE_CALLBACK : 'populate_youtube_search_results',
    SEARCH_DIALOG_WIDTH : 800,
    SEARCH_DIALOG_HEIGHT : 495,
    TOP_OFFSET : 90,
    DEFAULT_WIDTH : 420,
    DEFAULT_HEIGHT : 315,
    RESULTS_PER_PAGE : 10,
    YOUTUBE_SEARCH_REGION : 'us',
    cur_page : null, cur_search : null, cur_orderby : null, cur_maxpage : null,
    prevbtn : function () {
        $res = $(
            '<input type="submit" value="previous page" class="yt-prev" />');
        $res.css(
            {float: 'left', margin: '3px'}).click(ytsearch.prev_result_page);
        return $res;
    },
    nextbtn : function () {
        $res = $('<input type="submit" value="next page" class="yt-next" />');
        $res.css(
            {float: 'right', margin: '3px'}).click(ytsearch.next_result_page);
        return $res;
    },
    get_infodiv : function () {
        return $('<div></div>').append(
            ytsearch.prevbtn(), ytsearch.nextbtn(),
            '<div style="width: 100%; text-align: center;"><span class="yt-tot-found"></span><span class="yt-page-indicator" style="margin-left: 3em;"></span></div>');
    },
    set_result_count : function (n) {
        $('span.yt-tot-found').html(
            'Videos Found: <b>' + n + '</b>');
    },
    set_page_indicator : function () {
        if (ytsearch.cur_maxpage === null) {
            $('span.yt-page-indicator').empty();
        } else {
            $('span.yt-page-indicator').html(
                'Page <b>' + (ytsearch.cur_page+1) + '</b> of <b>'+
                ytsearch.cur_maxpage + '</b>');
        }
    },
    youtube_search_url : function (search_string, orderby, pagenum) {
        pagenum = pagenum ? pagenum : 0;
        var coded = escape(search_string.replace(/\s+/g, '+')),
            startindex = 1 + (pagenum * ytsearch.RESULTS_PER_PAGE),
            //params = '?key=' + ytsearch.YOUTUBE_API_KEY + '&q=' + coded + '&alt=json&orderby=' + orderby +
            params = '?key='+ ytsearch.YOUTUBE_API_KEY + 
								'&part=snippet' + 
								'&q=' + coded + 
								//'&alt=json' + 
								//'&orderby=' + orderby +
                // '&region=' + ytsearch.YOUTUBE_SEARCH_REGION +
                'maxResults=' + ytsearch.RESULTS_PER_PAGE +
                //'&start-index=' + startindex +
                '&callback=' + ytsearch.YOUTUBE_CALLBACK,
            result = 'https://www.googleapis.com/youtube/v3/search' + params;
        return result;
    },
    next_result_page : function () {
			ytsearch.get_youtube_search(ytsearch.cur_search, ytsearch.cur_orderby, ytsearch.cur_page + 1, ytsearch.YOUTUBE_NEXT);
			return false;
        if (ytsearch.cur_page === null) return;
        ytsearch.get_youtube_search(
            ytsearch.cur_search, ytsearch.cur_orderby, ytsearch.cur_page + 1);
    },
    prev_result_page : function () {
			ytsearch.get_youtube_search(ytsearch.cur_search, ytsearch.cur_orderby, ytsearch.cur_page - 1, ytsearch.YOUTUBE_PREV);
			return false;
        if (!ytsearch.cur_page) return;
        ytsearch.get_youtube_search(
            ytsearch.cur_search, ytsearch.cur_orderby, ytsearch.cur_page - 1);
    },
    submitsearch : function () {
        var searchstring = $('#ytsearchbox').val(),
            orderby = $('input:radio[name=ytorderby]:checked').val();
        ytsearch.get_youtube_search(searchstring, orderby);
    },
		
		keyWordsearch: function(q, orderby, pagenum, pageToken) {
        gapi.client.setApiKey(ytsearch.YOUTUBE_API_KEY);
        gapi.client.load('youtube', 'v3', function() {
                ytsearch.makeRequest(q, orderby, pagenum, pageToken);
        });
		},
    makeRequest: function(q, orderby, pagenum, pageToken) {
        var request = gapi.client.youtube.search.list({
                q: q,
                part: 'snippet', 
                maxResults: 10,
								order: orderby,
								pageToken: pageToken
        });
        request.execute(function(response)  {  
					populate_youtube_search_results(response);
        })    
		},
		
    get_youtube_search : function (search_string, orderby, pagenum, pageToken) {
				
				ytsearch.keyWordsearch(search_string, orderby, pagenum, pageToken);
				pagenum = pagenum ? pagenum : 0;
				ytsearch.cur_search = search_string;
        ytsearch.cur_orderby = orderby;
        ytsearch.cur_page = pagenum;
				if (ytsearch.cur_page === 0) {
            $('.yt-prev').attr('disabled', true);
        } else {
            $('.yt-prev').removeAttr('disabled');
        }
				return false;
        
        var url = ytsearch.youtube_search_url(search_string, orderby, pagenum);
        
        
        $('head').append('<script type="text/javascript" src="' +
                    url + '"></script>');
    },
    show_video : function (videoid) {
        $('#ytvideoid').val(videoid);
        $('#ytvideoembed').attr('src',
                    'http://www.youtube.com/embed/'+videoid+'?rel=0');
        $('#ytsearch').dialog('close');
        $('#ytvideo').dialog('open');
        return false;
    },
    insert_video : function () {
        var videoid = $('#ytvideoid').val(),
            w = $('#ytvideo_w').val(),
            h = $('#ytvideo_h').val(),
            wh_str = '';
        if (w !== ytsearch.DEFAULT_WIDTH || h !== ytsearch.DEFAULT_HEIGHT) {
            wh_str = 'width=' + w + ' height=' + h + ' ';
        }
        ytsearch.hide_all();
        tinyMCE.activeEditor.selection.setContent(
            '[embed '+ wh_str + 'rel=0]' +
                'http://www.youtube.com/watch?v=' + videoid +
                '[/embed]');
    },
    hide_video : function () {
        $('#ytvideoembed').attr('src', '');
        $('#ytvideo').dialog('close');
    },
    show_search : function () {
        ytsearch.hide_video();
        $('#ytsearch').dialog('open');
    },
    hide_all : function () {
        ytsearch.hide_video();
        $('#ytsearch').dialog('close');
    },
    create_search_result_item : function (item) {
        var result = $('<div class="yt-search-result">'), minutes, secs,
            href = 'http://www.youtube.com/watch?v=' + item.id.videoId;
        $(result).append(
                '<div class="img-div"></div>',
                '<div class="yt-search-text"></div>');
        $(result).find('.img-div').append('<a href="'+href+'"></a>');
        $(result).find('.img-div a').append(
                   '<img src="' + item.snippet.thumbnails.default.url + '" />');
        /*
				minutes = Math.floor(item.duration / 60);
        secs = item.duration % 60;
        secs = (secs < 10) ? '0' + secs : secs;
        $(result).find('.yt-search-text').append(
                '<a href="'+href+'">'+item.snippet.title+'</a>',
                '<br />', '<span>['+minutes+':'+secs+']</span>',
                '<br />', '<b>Views: ' + item.viewCount + '</b>'
        );
				*/
				$(result).find('.yt-search-text').append(
                '<a href="'+href+'">'+item.snippet.title+'</a>'
        );
        $(result).find('a').click(function () {
            return ytsearch.show_video(item.id.videoId);
        });
        return result;
    },

    tinymce_yt_button : function () {
        tinymce.PluginManager.requireLangPack('ytsearch');
        tinymce.create('tinymce.plugins.ytsearch', {
            init : function(ed, url) {
                ed.addCommand('ytsearch', function() {
                    ytsearch.show_search();
                });
                ed.addButton('ytsearch', {
                    title: 'YouTube search',
                    image: ytsearch.YOUTUBE_ICON,
                    cmd: 'ytsearch'
                });
                ed.addShortcut('alt+ctrl+y',
                            ed.getLang('ytsearch'), 'ytsearch');
            },
            createControl : function(n, cm) {
                return null;
            },
            getInfo : function() {
                return {
                    longname: 'YouTube Search Button',
                    author: 'Xybercode, inc.',
                    authorurl: 'http://www.xybercode.com/',
                    infourl: 'http://www.xybercode.com/',
                    version: '1.0'
                };
            }
        });
        tinymce.PluginManager.add('ytsearch', tinymce.plugins.ytsearch);
    },
    yt_search_dialog_init : function () {
        // search dialog and video display dialog
        $('body').append(
            '<div title="YouTube Search" id="ytsearch"></div>',
            '<div title="YouTube Video Display" id="ytvideo"></div>');
        $('#ytsearch').hide();
        $('#ytsearch').append(
            '<div id="ytsearchdiv"></div>',
            '<hr />', ytsearch.get_infodiv(), '<hr />',
            '<div id="ytsearchresults"></div>');
        $('#ytsearchdiv').append(
                '<input id="ytsearchbox" />',
                '<input id="ytsearchsubmit" type="submit" value="search" />',
                '<br />',
                '<span id="ytsortlabel">Sort by:</span>',

                '<input type="radio" name="ytorderby" value="relevance" '+
                            'checked="checked" id="ytob_rel" />',
                '<label for="ytob_rel">Relevance</label>',

                '<input type="radio" name="ytorderby" value="date" '+
                            'id="ytob_pub" />',
                '<label for="ytob_pub">Date</label>',

                '<input type="radio" name="ytorderby" value="viewCount" '+
                            'id="ytob_view" />',
                '<label for="ytob_view">Views</label>',

                '<input type="radio" name="ytorderby" value="rating" '+
                            'id="ytob_rat" />',
                '<label for="ytob_rat">Rating</label>'
        );
        $('#ytsearchsubmit').click(ytsearch.submitsearch);
        $('#ytsearch').dialog({
            autoOpen: false,
            modal: true,
            zIndex: 100000,
            width: ytsearch.SEARCH_DIALOG_WIDTH,
            dialogClass: 'wp-dialog',
            position: ['center', ytsearch.TOP_OFFSET]
        });

        // video display dialog
        $('#ytvideo').hide();
        $('#ytvideo').append(
            '<div id="ytvideodisplay"></div>',
            '<hr />',
            '<div id="ytvideoparams"></div>',
            '<hr />',
            '<div id="ytvideobuttons"></div>',
            '<input type="hidden" id="ytvideoid" />'
        );
        $('#ytvideodisplay').append(
                '<iframe id="ytvideoembed" width="' +
                    ytsearch.DEFAULT_WIDTH +
                    '" height="' +
                    ytsearch.DEFAULT_HEIGHT +
                    '" frameborder="0" allowfullscreen></iframe>');
        $('#ytvideoparams').append(
            '<span id="ytvideo_w_span">' +
                '<label for="ytvideo_w">Width</label>' +
                '<input id="ytvideo_w" value="' +
                ytsearch.DEFAULT_WIDTH + '"/></span>',
            '<span id="ytvideo_h_span">' +
                '<label for="ytvideo_h">Height</label>' +
                '<input id="ytvideo_h" value="' +
                ytsearch.DEFAULT_HEIGHT + '"/></span>', '<br />'
        );
        $('#ytvideobuttons').append(
                '<input type="submit" id="ytbackbtn" ' +
                        'value="Back to Search Results" />',
                '<input type="submit" id="ytinsertbtn" ' +
                        'value="Insert Selected Video" />'
        );
        $('#ytbackbtn').click(ytsearch.show_search);
        $('#ytinsertbtn').click(ytsearch.insert_video);
        $('#ytvideo').dialog({
            autoOpen: false,
            modal: true,
            zIndex: 100000,
            width: ytsearch.SEARCH_DIALOG_WIDTH,
            height: ytsearch.SEARCH_DIALOG_HEIGHT,
            dialogClass: 'wp-dialog'
        });
    },
    set_no_results : function () {
    }
  };
})(jQuery);

populate_youtube_search_results = function (json_obj) {
    var items = json_obj.items,
        totalItems = json_obj.pageInfo.totalResults;
		ytsearch.YOUTUBE_PREV = json_obj.prevPageToken;
		ytsearch.YOUTUBE_NEXT = json_obj.nextPageToken;
    if (ytsearch.cur_page === ytsearch.cur_maxpage-1) {
        jQuery('.yt-next').attr('disabled', true);
    } else {
        jQuery('.yt-next').removeAttr('disabled');
    }
    jQuery('#ytsearchresults').empty();
    if (!items) {
        ytsearch.set_result_count(0);
        ytsearch.cur_maxpage = null;
        ytsearch.set_page_indicator();
        return;
    }
    jQuery(items).each(function () {
        jQuery('#ytsearchresults').append(
                    ytsearch.create_search_result_item(this));
    });
    jQuery('#ytsearchresults').append(ytsearch.get_infodiv());
    ytsearch.set_result_count(totalItems);
    ytsearch.cur_maxpage = Math.ceil(
                parseInt(totalItems) / ytsearch.RESULTS_PER_PAGE);
    ytsearch.set_page_indicator();
    var titlebar_height = jQuery('.ui-dialog-titlebar').height(),
        total_height = jQuery('#ytsearchdiv').height() +
            jQuery('#ytsearchresults').height() + titlebar_height + 35,
        height = Math.min(total_height, ytsearch.SEARCH_DIALOG_HEIGHT);
    jQuery('#ytsearch').dialog('option', 'height', height);
};

jQuery(function () {
    ytsearch.tinymce_yt_button();
    ytsearch.yt_search_dialog_init();
});