<?php

/** ********************** Ad bar functionality *************************/

add_action('wp_enqueue_scripts', 'tn_adbar');
function tn_adbar() {
    $fulloptions = get_option(TN_ADBAR_OPTION);
    if (!$fulloptions['show_adbar']) return;
    if ($fulloptions['use_a_b']) {
        if (mt_rand(0, 1) === 0 ) {
            $options = $fulloptions['a'];
            $version = 'version-a';
        } else {
            $options = $fulloptions['b'];
            $version = 'version-b';
        }
    } else {
        $options = $fulloptions['a'];
        $version = 'version-a';
    }
    $loadurl = home_url(TN_ADBAR_STAT_LINK_ROOT.'/load/'.$version);
    $clickurl = home_url(TN_ADBAR_STAT_LINK_ROOT.'/click/'.$version);
    extract($options);
    ?>
    <script type="text/javascript">
        tn_adbar_message = <?php echo json_encode($message); ?>;
        tn_adbar_linktext = <?php echo json_encode($linktext); ?>;
        tn_adbar_linkurl = <?php echo json_encode($linkurl); ?>;
        tn_adbar_loadurl = <?php echo json_encode($loadurl); ?>;
        tn_adbar_clickurl = <?php echo json_encode($clickurl); ?>;
    </script>
    <?php
    $lineheight = $size * 2;
    $fontstyle = "bold {$size}px $font"; ?>
    <style type="text/css">
    #tn-adbar {
        font: <?php echo $fontstyle; ?>;
        color: <?php echo $color; ?>;
        background-color: <?php echo $bgcolor; ?>;
        border-bottom: 4px <?php echo $bordercolor; ?> solid;
        height: <?php echo (2*$size); ?>px;
        /* padding: 0px 0px <?php echo 2+ceil(($size/12)*3); ?>px 0px; */
    }
    #tn-adbar-content {
        /* top: <?php echo (int)($size/2) ?>px; */
        font: <?php echo $fontstyle; ?>;
        line-height: <?php echo $lineheight; ?>px;
        height: <?php echo (2*$size); ?>px;
    }
    #tn-adbar .adbar-btn {
        background-color: <?php echo $linkbgcolor; ?>;
        color: <?php echo $linktextcolor; ?>;
        font: <?php echo $fontstyle; ?>;
        line-height: <?php echo $size; ?>px;
        /* border: 1px solid <?php echo $linktextcolor; ?>; */
        /* border-color: <?php echo $linktextcolor; ?>; */
        /* border-width: 1px; */
        border-radius: <?php echo 2+ceil(($size/12)*3); ?>px;
    }
    #tn-adbar .adbar-btn:hover {
        background-color: <?php echo $mouseover_linkbgcolor; ?>;
    }
    </style>
    <?php
    wp_enqueue_style('tn_adbar',
                plugins_url('/css/tn-adbar.css', __FILE__));
    wp_enqueue_script('tn_adbar',
                plugins_url('/js/tn-adbar.js', __FILE__),
                array('jquery', 'jquery-ui-position', 'jquery-ui-button'));
}

function tn_adbar_get_mouseover_color($color) { // color is a #rrggbb triplet
    if (!preg_match('/^#[0-9a-fA-F]{6}$/', $color)) return $color;
    $r = hexdec(substr($color, 1, 2));
    $g = hexdec(substr($color, 3, 2));
    $b = hexdec(substr($color, 5, 2));
    $v = max($r, $g, $b);
    $ratio = ($v <= 0x7f ? 1.5 : 0.75);
    $r *= $ratio; $g *= $ratio; $b *= $ratio;
    if ($r == 0 && $g == 0 && $b == 0) {
        $r = 0x33; $g = 0x33; $b = 0x33;
    }
    $r = ($r < 0x10 ? '0' : '') . dechex(floor($r));
    $g = ($g < 0x10 ? '0' : '') . dechex(floor($g));
    $b = ($b < 0x10 ? '0' : '') . dechex(floor($b));
    $result = "#$r$g$b";
    return $result;
}